{***************************************************************
 *
 * Unit Name: amnextr1
 * Purpose  : Interfaceto amnextract.dll
 * Author   :  Alexey M. Novosselov /amnsoft@angelfire.com
 * History  :
 *
 ****************************************************************}


unit amnextr1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
TzType = (zAdd, zMove);

procedure Extract(Handl: hInst; DialogCaption, Source, Destination, Mask: string; Stored,
  OverwriteFiles: Boolean);
//function GetVersion: DWORD;
//procedure About(Handl: hInst);
function Verify(Handl: hInst; DialogCaption, FileName: string): WordBool;
procedure Zip(Handl: hInst; DlgCaption, FileName: string; Files: TStrings; StoredDir:
  WordBool; Kind: TzType);

procedure View(Handl: hInst; DlgCaption, FileName: string);

//procedure SilentExtract(Source, Destination: string; Stored: Boolean; Progress: Integer);

var
  _Extract: procedure(Handl: hInst; DlgCaption, FileName, Destination, Mask: PChar;
    StoredDir, Overwrite: WordBool); stdcall;

//  _GetVersion: function: DWORD; stdcall;

//  _About: procedure(Hndl: hInst); stdcall;

  _Verify: function(Handl: hInst; DlgCaption, FileName: PChar): WordBool;
    stdcall;

  _Zip: procedure(Handl: hInst; DlgCaption, FileName: PChar; Files: TStrings;
    StoredDir: WordBool; Operation: TzType); stdcall;

  _View: procedure(Handl: hInst; DlgCaption, FileName: PChar); stdcall;


implementation

procedure Extract(Handl: hInst; DialogCaption, Source, Destination, Mask: string; Stored,
  OverwriteFiles: Boolean);
var
  h: hInst;
begin
  h := LoadLibrary(PChar('amnextr.dll'));
  if h <> 0 then
    begin
      try
        @_Extract := GetProcAddress(h, PChar('_Extract'));
        _Extract(Handl, PChar(DialogCaption), PChar(Source),
          PChar(Destination), PChar(Mask), Stored, OverwriteFiles);
      finally
        FreeLibrary(h);
      end;
    end;
end;

//function GetVersion: DWORD;
//var
//  h: hInst;
//begin
//  h := LoadLibrary(PChar('amnextr.dll'));
//  try
//    if h <> 0 then
//      begin
//        @_GetVersion := GetProcAddress(h, PChar('_GetVersion'));
//        Result := _GetVersion;
//      end
//    else
//      begin
//        if h = 0 then
//          Result := 0;
//      end;
//  finally
//    FreeLibrary(h);
//  end;
//end;


//procedure About(Handl: hInst);
//var
//  h: hInst;
//begin
//  h := LoadLibrary(PChar('amnextr.dll'));
//  try
//    if h <> 0 then
//      begin
//        @_About := GetProcAddress(h, PChar('_About'));
//        _About(Handl);
//      end
//    else
//      Exit;
//  finally
//    FreeLibrary(h);
//  end;
//end;


function Verify(Handl: hInst; DialogCaption, FileName: string): WordBool;
var
  h: hInst;
  Lst: TStringList;
begin
  h := LoadLibrary(PChar('amnextr.dll'));
  if h <> 0 then
    begin
      try
        @_Verify := GetProcAddress(h, PChar('_Verify'));
        Lst:= TStringList.Create;
        Result :=_Verify(Handl, PChar(DialogCaption),
          PChar(FileName));
      finally
        FreeLibrary(h);
      end;
    end;
end;


procedure View(Handl: hInst; DlgCaption, FileName: string);
var
  h: hInst;
begin
  h := LoadLibrary(PChar('amnextr.dll'));
  if h <> 0 then
   // begin
      try
        @_View := GetProcAddress(h, PChar('_View'));
        _View(Handl, PChar(DlgCaption), PChar(FileName));
      finally
        FreeLibrary(h);
  //    end;
    end;
end;


procedure Zip(Handl: hInst; DlgCaption, FileName: string; Files: TStrings; StoredDir:
  WordBool; Kind: TzType);
var
  h: hInst;
begin
  h := LoadLibrary(PChar('amnextr.dll'));
  if h <> 0 then
   // begin
      try
        @_Zip := GetProcAddress(h, PChar('_Zip'));
        _Zip(Handl, PChar(DlgCaption), PChar(FileName), Files, StoredDir, Kind);
      finally
        FreeLibrary(h);
  //    end;
    end;
end;
end.

 